/* YAWN, Yet Another Web Navigator */
/* Copyright (C) 1998, James Troup <jjtroup@comp.brad.ac.uk>
 *                     Lee Willis <lwillis@comp.brad.ac.uk> */

/* This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License as
 * published by the Free Software Foundation; either version 2 of the
 * License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful, but
 * WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 */

#ifndef __PARSE_ATTRIBS_H__
#define __PARSE_ATTRIBS_H__

#include "neve.h"

void handle_src (const char *document, long *index, neve_in_chains *node, const int tag);
void handle_href (const char *document, long *index, int tag, char *current_href, BrowserWindow *window);
void handle_align (const char *document, long *index, neve_in_chains *node, int tag, physical_attribute_types *current_pattributes);
void handle_unrecognized (const char *document, long *index);
void handle_size (const char *document, long *index,neve_in_chains *node, int tag, int *basefont, 
		  int *font_change_implemented, physical_attribute_types *current_pattributes);
void handle_colour(const char *document, long *index, const int tag, 
		   boolean *font_change_implemented, 
		   physical_attribute_types *current_pattributes);
void handle_alt (const char *document, long *index, neve_in_chains *node, int tag);
void handle_type (const char *document, long *index, logical_attribute_types *lattribs, int tag);
void handle_width (const char *document, long *index, neve_in_chains *node, int tag);
void handle_height (const char *document, long *index, neve_in_chains *node, int tag);
void handle_bgcolor (BrowserWindow *window, const char *document, long *index, int tag);
void handle_text (const char *document, long *index, int tag, physical_attribute_types *pattribs);
void handle_link (BrowserWindow *window, const char *document, long *index, int tag);
void handle_alink (BrowserWindow *window, const char *document, long *index, int tag);
void handle_vlink (BrowserWindow *window, const char *document, long *index, int tag);
void parse_attribs (BrowserWindow *window, const char *document,long *index, neve_in_chains *neve_node, 
		    int tag, int *current_basefont, physical_attribute_types *current_pattribs, 
		    logical_attribute_types *current_lattribs, char *current_href);

char foo[10];

#endif /* __PARSE_ATTRIBS_H__ */
