/* YAWN, Yet Another Web Navigator */
/* Copyright (C) 1997, 1998, James Troup <jjtroup@comp.brad.ac.uk>
 *                     Lee Willis <lwillis@comp.brad.ac.uk> */

/* This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License as
 * published by the Free Software Foundation; either version 2 of the
 * License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful, but
 * WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 */

#ifndef SMG_UTIL_H
#define SMG_UTIL_H

#include <sys/types.h>

/* string.c */

int is_whitespace (const char text);

/* xmalloc.c */

void *fixup_null_alloc (size_t n);
void *xmalloc (size_t n);

/* error.c */

void debug (const int message_level, const char *fmt,...) __attribute__ ((format (printf, 2, 3)));
void error (const char *fmt,...) __attribute__ ((format (printf, 1, 2)));
void fubar (unsigned short flag, const char *fmt,...) __attribute__ ((noreturn, format (printf, 2, 3)));
void debug_help (void);

/* Flags for debug */

#define debug_warn        0001	/* General warnings */
#define debug_neve        0002	/* neve - (DS for HTML post parsing) */
#define debug_render      0004	/* render - HTML rendering code */
#define debug_lisa        0010	/* lisa - (HTML rendering widget) */
#define debug_lisa_scroll 0020	/* lisa's scrolling code */
#define debug_lisa_expose 0040	/* lisa's expose routines */


#define debug_parser        0100	/* parser - Lee's parser */
#define debug_parse_attribs 0200	/* parser - attribute handling */
#define debug_scanner       0400	/* parser - scanner */

#define debug_cole          1000	/* Network and file handling code */
#define debug_alyson        2000        /* Alyson */

#define debug_chloe         4000        /* Real network code */

/* Flags for fubar */

#define NONSYS 0x0001
#define SYSERR 0x0002

#endif /* SMG_UTIL_H */
